blob: d645a5346cb61a630709b6fb15152b2fd634e818 [file] [log] [blame]
Peter Stuge09377b72011-08-21 06:24:55 +02001#!/bin/sh
Stefan Reinauer074d9132009-09-26 16:43:17 +00002#
Stefan Reinauer5f1ad892010-05-17 11:02:25 +00003# Copyright (C) 2008-2010 by coresystems GmbH
Stefan Reinauer074d9132009-09-26 16:43:17 +00004# written by Patrick Georgi <patrick.georgi@coresystems.de> and
5# Stefan Reinauer <stefan.reinauer@coresystems.de>
Stefan Reinauer14e22772010-04-27 06:56:47 +00006#
Marc Jones2aac3f62011-08-08 16:07:50 -06007# Copyright (C) 2011 by Sage Electronic Engineering
8#
Stefan Reinauer074d9132009-09-26 16:43:17 +00009# This program is free software; you can redistribute it and/or modify
10# it under the terms of the GNU General Public License as published by
11# the Free Software Foundation; version 2 of the License.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the GNU General Public License
19# along with this program; if not, write to the Free Software
Patrick Georgib890a122015-03-26 15:17:45 +010020# Foundation, Inc.
Stefan Reinauer074d9132009-09-26 16:43:17 +000021#
22
Stefan Reinauerd7649122015-06-09 11:44:25 -070023cd $(dirname $0)
Patrick Georgi8135dba2015-03-17 21:05:20 +010024
Patrick Georgiaf473ed2015-07-17 23:35:54 +020025CROSSGCC_DATE="July 17th, 2015"
26CROSSGCC_VERSION="1.32"
Stefan Reinauer074d9132009-09-26 16:43:17 +000027
28# default settings
Stefan Reinauer85b07d62015-06-09 14:45:14 -070029PACKAGE=GCC
Stefan Reinauerd7649122015-06-09 11:44:25 -070030TARGETDIR=$(pwd)/xgcc
Stefan Reinauer074d9132009-09-26 16:43:17 +000031TARGETARCH=i386-elf
32DESTDIR=
Stefan Reinauer85b07d62015-06-09 14:45:14 -070033SAVETEMPS=0
34SKIPPYTHON=1
Stefan Reinauer074d9132009-09-26 16:43:17 +000035
Stefan Reinauer699ac272015-06-05 12:43:28 -070036# GCC toolchain version numbers
Patrick Georgi53c388f2015-03-07 09:55:18 +010037GMP_VERSION=6.0.0
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070038MPFR_VERSION=3.1.2
Paul Menzele6619422015-02-23 10:33:59 +010039MPC_VERSION=1.0.3
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000040LIBELF_VERSION=0.8.13
Patrick Georgiaf473ed2015-07-17 23:35:54 +020041GCC_VERSION=5.2.0
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070042GCC_AUTOCONF_VERSION=2.69
Patrick Georgi53c388f2015-03-07 09:55:18 +010043BINUTILS_VERSION=2.25
Stefan Reinauerbed95b22015-06-09 13:41:40 -070044GDB_VERSION=7.9.1
Stefan Reinaueradf61e22015-07-07 00:41:42 +020045IASL_VERSION=20150619
Patrick Georgi53c388f2015-03-07 09:55:18 +010046PYTHON_VERSION=3.4.3
Idwer Vollering296a0152012-10-26 01:48:04 +020047EXPAT_VERSION=2.1.0
Stefan Reinauer14ce2132015-06-05 13:01:13 -070048# CLANG version number
49CLANG_VERSION=3.6.1
Stefan Reinauer074d9132009-09-26 16:43:17 +000050
Stefan Reinauer699ac272015-06-05 12:43:28 -070051# GCC toolchain archive locations
Patrick Georgi53c388f2015-03-07 09:55:18 +010052GMP_ARCHIVE="http://ftpmirror.gnu.org/gmp/gmp-${GMP_VERSION}a.tar.bz2"
Patrick Georgi6e61ad32012-05-12 23:19:30 +020053MPFR_ARCHIVE="http://ftpmirror.gnu.org/mpfr/mpfr-${MPFR_VERSION}.tar.bz2"
Idwer Vollering7962fc72012-10-25 02:14:09 +020054MPC_ARCHIVE="http://ftpmirror.gnu.org/mpc/mpc-${MPC_VERSION}.tar.gz"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000055LIBELF_ARCHIVE="http://www.mr511.de/software/libelf-${LIBELF_VERSION}.tar.gz"
Idwer Vollering1cfee0b2012-10-25 02:03:53 +020056GCC_ARCHIVE="http://ftpmirror.gnu.org/gcc/gcc-${GCC_VERSION}/gcc-${GCC_VERSION}.tar.bz2"
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070057BINUTILS_ARCHIVE="http://ftpmirror.gnu.org/binutils/binutils-${BINUTILS_VERSION}.tar.bz2"
Patrick Georgi53c388f2015-03-07 09:55:18 +010058GDB_ARCHIVE="http://ftpmirror.gnu.org/gdb/gdb-${GDB_VERSION}.tar.xz"
59IASL_ARCHIVE="https://acpica.org/sites/acpica/files/acpica-unix-${IASL_VERSION}.tar.gz"
60PYTHON_ARCHIVE="http://www.python.org/ftp/python/${PYTHON_VERSION}/Python-${PYTHON_VERSION}.tar.xz"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010061EXPAT_ARCHIVE="http://downloads.sourceforge.net/sourceforge/expat/expat-${EXPAT_VERSION}.tar.gz"
Stefan Reinauer14ce2132015-06-05 13:01:13 -070062# CLANG toolchain archive locations
63LLVM_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/llvm-${CLANG_VERSION}.src.tar.xz"
64CFE_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/cfe-${CLANG_VERSION}.src.tar.xz"
65CRT_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/compiler-rt-${CLANG_VERSION}.src.tar.xz"
66CTE_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/clang-tools-extra-${CLANG_VERSION}.src.tar.xz"
Stefan Reinauer074d9132009-09-26 16:43:17 +000067
Stefan Reinauer699ac272015-06-05 12:43:28 -070068# GCC toolchain directories
Stefan Reinauer074d9132009-09-26 16:43:17 +000069GMP_DIR="gmp-${GMP_VERSION}"
70MPFR_DIR="mpfr-${MPFR_VERSION}"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000071MPC_DIR="mpc-${MPC_VERSION}"
72LIBELF_DIR="libelf-${LIBELF_VERSION}"
Stefan Reinauer074d9132009-09-26 16:43:17 +000073GCC_DIR="gcc-${GCC_VERSION}"
74BINUTILS_DIR="binutils-${BINUTILS_VERSION}"
75GDB_DIR="gdb-${GDB_VERSION}"
Marc Jones2aac3f62011-08-08 16:07:50 -060076IASL_DIR="acpica-unix-${IASL_VERSION}"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010077PYTHON_DIR="Python-${PYTHON_VERSION}"
78EXPAT_DIR="expat-${EXPAT_VERSION}"
Stefan Reinauer14ce2132015-06-05 13:01:13 -070079# CLANG toolchain directories
80LLVM_DIR="llvm-${CLANG_VERSION}.src"
81CFE_DIR="cfe-${CLANG_VERSION}.src"
82CRT_DIR="compiler-rt-${CLANG_VERSION}.src"
83CTE_DIR="clang-tools-extra-${CLANG_VERSION}.src"
Stefan Reinauer074d9132009-09-26 16:43:17 +000084
Patrick Georgi6321f522015-02-27 23:36:26 +010085unset MAKELEVEL MAKEFLAGS
86
Patrick Georgi1861ff72011-10-31 12:15:55 +010087red='\033[0;31m'
88RED='\033[1;31m'
89green='\033[0;32m'
90GREEN='\033[1;32m'
91blue='\033[0;34m'
92BLUE='\033[1;34m'
93cyan='\033[0;36m'
94CYAN='\033[1;36m'
95NC='\033[0m' # No Color
Stefan Reinauer074d9132009-09-26 16:43:17 +000096
zbaoe05c1ea2015-08-05 23:10:05 -040097UNAME=$(uname | grep -iq cygwin && echo Cygwin || uname)
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070098
Patrick Georgi198d23c2012-12-08 08:02:44 +010099normalize_dirs()
100{
101 mkdir -p $DESTDIR$TARGETDIR/lib
102 test -d $DESTDIR$TARGETDIR/lib32 && mv $DESTDIR$TARGETDIR/lib32/* $DESTDIR$TARGETDIR/lib
103 test -d $DESTDIR$TARGETDIR/lib64 && mv $DESTDIR$TARGETDIR/lib64/* $DESTDIR$TARGETDIR/lib
104 rmdir -p $DESTDIR$TARGETDIR/lib32 $DESTDIR$TARGETDIR/lib64
105
106 perl -pi -e "s,/lib32,/lib," $DESTDIR$TARGETDIR/lib/*.la
107 perl -pi -e "s,/lib64,/lib," $DESTDIR$TARGETDIR/lib/*.la
108}
109
Stefan Reinauer93a96302015-06-15 12:36:53 -0700110please_install()
111{
Patrick Georgi5da95dc2015-07-17 23:33:05 +0200112 test -r /etc/os-release && . /etc/os-release
Stefan Reinauer93a96302015-06-15 12:36:53 -0700113 case "$ID_LIKE" in
114 debian) solution="sudo apt-get install $1" ;;
115 suse) solution="sudo zypper install $1" ;;
116 *) solution="using your OS packaging system" ;;
117 esac
118
119 printf "${RED}ERROR:${red} Missing tool: Please install \'$1\' utility. (eg $solution)${NC}\n" >&2
120}
121
Patrick Georgib7062882015-02-24 10:52:14 +0100122searchtool()
Stefan Reinauer074d9132009-09-26 16:43:17 +0000123{
124 # $1 short name
Patrick Georgib7062882015-02-24 10:52:14 +0100125 # $2 search string
126 # $3 soft fail if set
127 # result: file name of that tool on stdout
128 # or no output if nothing suitable was found
129 search=GNU
130 if [ -n "$2" ]; then
131 search="$2"
132 fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000133 for i in "$1" "g$1" "gnu$1"; do
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700134 if [ -x "$(which $i 2>/dev/null)" ]; then
135 if [ "$(cat /dev/null | $i --version 2>&1 | grep -c "$search")" \
136 -gt 0 ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000137 echo $i
138 return
139 fi
140 fi
141 done
Andrew Wub67e9a12014-04-28 18:13:44 +0800142 # A workaround for OSX 10.9 and some BSDs, whose nongnu
143 # patch and tar also work.
Patrick Georgi7cb26b42015-04-28 21:29:22 +0200144 if [ $UNAME = "Darwin" -o $UNAME = "FreeBSD" -o $UNAME = "NetBSD" -o $UNAME = "OpenBSD" ]; then
Patrick Georgib7062882015-02-24 10:52:14 +0100145 if [ "$1" = "patch" -o "$1" = "tar" ]; then
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700146 if [ -x "$(which $1 2>/dev/null)" ]; then
Zheng Bao36156ff2012-09-28 16:18:58 +0800147 echo $1
148 return
149 fi
150 fi
151 fi
Stefan Reinauerd7649122015-06-09 11:44:25 -0700152 if [ "$(echo $1 | cut -b -3)" = "sha" ]; then
zbao939dc842015-04-30 04:44:07 +0800153 if [ $UNAME = "FreeBSD" ]; then
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700154 if [ -x "$(which sha1 2>/dev/null)" ]; then
zbao939dc842015-04-30 04:44:07 +0800155 echo sha1
156 return
157 fi
158 fi
159 if [ $UNAME = "NetBSD" ]; then
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700160 if [ -x "$(which cksum 2>/dev/null)" ]; then
Stefan Reinauerd7649122015-06-09 11:44:25 -0700161 echo cksum -a $(echo $1 | sed -e 's,sum,,')
zbao939dc842015-04-30 04:44:07 +0800162 return
163 fi
164 fi
165 if [ $UNAME = "Darwin" ]; then
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700166 if [ -x "$(which openssl 2>/dev/null)" ]; then
Stefan Reinauerd7649122015-06-09 11:44:25 -0700167 echo openssl $(echo $1 | sed -e 's,sum,,')
zbao939dc842015-04-30 04:44:07 +0800168 return
169 fi
170 fi
171 fi
Stefan Reinauer93a96302015-06-15 12:36:53 -0700172 please_install $1
Patrick Georgib7062882015-02-24 10:52:14 +0100173 [ -z "$3" ] && exit 1
174 false
Stefan Reinauer074d9132009-09-26 16:43:17 +0000175}
176
Stefan Reinauer88935482015-06-05 09:51:10 -0700177download() {
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700178 package=$1
179 archive="$(eval echo \$$package"_ARCHIVE")"
Stefan Reinauer699ac272015-06-05 12:43:28 -0700180
Stefan Reinauerd7649122015-06-09 11:44:25 -0700181 FILE=$(basename $archive)
Stefan Reinauer88935482015-06-05 09:51:10 -0700182 printf " * $FILE "
183
184 test -f tarballs/$FILE && \
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700185 ( test -z "$CHECKSUM" || \
186 test "$(cat sum/$FILE.cksum 2>/dev/null | \
187 sed -e 's,.*\([0-9a-f]\{40\}\).*,\1,')" = \
188 "$($CHECKSUM tarballs/$FILE 2>/dev/null | \
189 sed -e 's,.*\([0-9a-f]\{40\}\).*,\1,')" ) && \
Stefan Reinauer88935482015-06-05 09:51:10 -0700190 printf "(cached)" || (
Paul Menzelb2ba3952015-06-12 11:58:14 +0200191 printf "(downloading from $archive)"
Stefan Reinauer88935482015-06-05 09:51:10 -0700192 rm -f tarballs/$FILE
193 cd tarballs
Stefan Reinauer699ac272015-06-05 12:43:28 -0700194 wget --no-check-certificate -q $archive
Stefan Reinauer88935482015-06-05 09:51:10 -0700195 cd ..
196 test ! -f sum/$FILE.cksum && test -f tarballs/$FILE && \
197 (test -z "$CHECKSUM" || $CHECKSUM tarballs/$FILE > sum/$FILE.cksum ) && \
198 printf "(checksum created. ${RED}Note. Please upload sum/$FILE.cksum if the corresponding archive is upgraded.${NC})"
199 )
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700200 if [ ! -f tarballs/$FILE ]; then
Stefan Reinauer88935482015-06-05 09:51:10 -0700201 printf "\n${RED}Failed to download $FILE.${NC}\n"
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700202 exit 1
203 fi
Stefan Reinauer88935482015-06-05 09:51:10 -0700204 printf "\n"
205}
206
207unpack_and_patch() {
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700208 package=$1
209 archive="$(eval echo \$$package"_ARCHIVE")"
210 dir="$(eval echo \$$package"_DIR")"
Stefan Reinauer88935482015-06-05 09:51:10 -0700211 test -d ${dir} && test -f ${dir}/.unpack_success || (
Stefan Reinauerd7649122015-06-09 11:44:25 -0700212 printf " * $(basename $archive)\n"
Stefan Reinauer88935482015-06-05 09:51:10 -0700213 FLAGS=zxf
Stefan Reinauerd7649122015-06-09 11:44:25 -0700214 suffix=$(echo $archive | sed 's,.*\.,,')
Stefan Reinauer88935482015-06-05 09:51:10 -0700215 test "$suffix" = "gz" && FLAGS=zxf
216 test "$suffix" = "bz2" && FLAGS=jxf
217 test "$suffix" = "xz" && FLAGS="--xz -xf"
218 test "$suffix" = "lzma" && FLAGS="--lzma -xf"
Stefan Reinauerd7649122015-06-09 11:44:25 -0700219 $TAR $FLAGS tarballs/$(basename $archive)
Stefan Reinauer88935482015-06-05 09:51:10 -0700220 for patch in patches/${dir}_*.patch; do
221 test -r $patch || continue
Stefan Reinauerd7649122015-06-09 11:44:25 -0700222 printf " o $(basename $patch)\n"
Stefan Reinauer916b8452015-06-09 11:54:49 -0700223 $PATCH -s -N -p0 < $(echo $patch) || {
Stefan Reinauer88935482015-06-05 09:51:10 -0700224 printf "\n${RED}Failed $patch.${NC}\n"
Stefan Reinauer916b8452015-06-09 11:54:49 -0700225 exit 1
226 }
Stefan Reinauer88935482015-06-05 09:51:10 -0700227 done
228 touch ${dir}/.unpack_success
229 )
230}
231
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700232fn_exists()
233{
Patrick Georgic8665912015-06-11 21:04:31 +0200234 type $1 >/dev/null 2>&1
Patrick Georgi74c06422015-03-25 18:40:13 +0100235}
236
Patrick Georgif2c15f52015-06-11 21:07:31 +0200237is_package_enabled()
238{
239 echo "$PACKAGES" |grep -q "\<$1\>"
240}
241
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700242build() {
243 package=$1
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700244
245 fn_exists build_$package || return
246
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700247 version="$(eval echo \$$package"_VERSION")"
248 BUILDDIR=build-${TARGETARCH}-$package
249
250 mkdir -p ${BUILDDIR}
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700251
Patrick Georgif2c15f52015-06-11 21:07:31 +0200252 is_package_enabled "$package" && \
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700253 if [ -f ${BUILDDIR}/.success ]; then
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700254 printf "Skipping $package as it is already built\n"
255 else
256 printf "Building $package $version ... "
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700257 DIR=$PWD
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700258 cd ${BUILDDIR}
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700259 rm -f .failed
260 build_${package} > build.log 2>&1
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700261 cd $DIR/${BUILDDIR}
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700262 if [ ! -f .failed ]; then touch .success; fi
263 cd ..
264
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700265 if [ -r "${BUILDDIR}/.failed" ]; then
266 printf "${RED}failed${NC}. Check ${BUILDDIR}/build.log.\n"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700267 exit 1
268 fi
269 printf "${green}ok${NC}\n"
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700270 fi
271}
272
Stefan Reinauer074d9132009-09-26 16:43:17 +0000273cleanup()
274{
275 printf "Cleaning up temporary files... "
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700276 for package in $PACKAGES; do
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700277 rm -rf build-${TARGETARCH}-$package $(eval echo \$$package"_DIR")
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700278 done
Stefan Reinauer074d9132009-09-26 16:43:17 +0000279 printf "${green}ok${NC}\n"
280}
281
282myhelp()
283{
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700284 printf "Usage: $0 [-V] [-c] [-p <platform>] [-d <target directory>] [-D <dest dir>] [-C] [-G] [-S]\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000285 printf " $0 [-V|--version]\n"
286 printf " $0 [-h|--help]\n\n"
287
288 printf "Options:\n"
289 printf " [-V|--version] print version number and exit\n"
290 printf " [-h|--help] print this help and exit\n"
291 printf " [-c|--clean] remove temporary files before build\n"
292 printf " [-t|--savetemps] don't remove temporary files after build\n"
Patrick Georgic1a75b12011-11-04 21:37:14 +0100293 printf " [-y|--ccache] Use ccache when building cross compiler\n"
Patrick Georgi73166c72010-04-14 20:42:42 +0000294 printf " [-j|--jobs <num>] run <num> jobs in parallel in make\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000295 printf " [-d|--directory <target dir>] target directory to install cross compiler to\n"
296 printf " (defaults to $TARGETDIR)\n\n"
297 printf " [-D|--destdir <dest dir>] destination directory to install cross compiler to\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100298 printf " (for RPM builds, default unset)\n"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700299 printf " [-P|--package <package>] Build a specific package: GCC, CLANG, IASL, GDB\n"
300 printf " (defaults to $PACKAGE)\n"
301 printf "GCC specific options:\n"
302 printf " [-p|--platform <platform>] target platform to build cross compiler for\n"
303 printf " (defaults to $TARGETARCH)\n"
304 printf "GDB specific options:\n"
305 printf " [-p|--platform <platform>] target platform to build cross compiler for\n"
306 printf " (defaults to $TARGETARCH)\n"
307 printf " [-S|--scripting] build scripting support for GDB\n\n"
Martin Rothd1da74f2015-06-21 12:06:28 -0600308 printf "Platforms for GCC & GDB:\n"
309 printf " x86_64 i386-elf i386-mingw32 mipsel-elf riscv-elf arm aarch64\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000310}
311
312myversion()
313{
314 # version tag is always printed, so just print the license here
315
316 cat << EOF
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000317Copyright (C) 2008-2010 by coresystems GmbH
Marc Jones2aac3f62011-08-08 16:07:50 -0600318Copyright (C) 2011 by Sage Electronic Engineering
Stefan Reinauer074d9132009-09-26 16:43:17 +0000319
320This program is free software; you can redistribute it and/or modify
321it under the terms of the GNU General Public License as published by
322the Free Software Foundation; version 2 of the License.
323
324This program is distributed in the hope that it will be useful,
325but WITHOUT ANY WARRANTY; without even the implied warranty of
326MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
327GNU General Public License for more details.
328
329EOF
330}
331
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700332build_GMP() {
333 CC="$CC" CFLAGS="-Os" ../${GMP_DIR}/configure --disable-shared --enable-fat --prefix=$TARGETDIR $OPTIONS \
334 || touch .failed
335 $MAKE $JOBS || touch .failed
336 $MAKE install DESTDIR=$DESTDIR || touch .failed
337
338 normalize_dirs
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700339
340 # Now set CFLAGS to match GMP CFLAGS but strip out -pedantic
341 # as GCC 4.6.x fails if it's there.
342 export HOSTCFLAGS=$(grep __GMP_CFLAGS $DESTDIR$TARGETDIR/include/gmp.h |cut -d\" -f2 |\
343 sed s,-pedantic,,)
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700344}
345
346build_MPFR() {
347 test $UNAME = "Darwin" && CFLAGS="$CFLAGS -force_cpusubtype_ALL"
348 CC="$CC" ../${MPFR_DIR}/configure --disable-shared --prefix=$TARGETDIR \
349 --infodir=$TARGETDIR/info \
350 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
351 touch .failed
352 $MAKE $JOBS || touch .failed
353 $MAKE install DESTDIR=$DESTDIR || touch .failed
354
355 normalize_dirs
356
357 # work around build problem of libgmp.la
358 if [ "$DESTDIR" != "" ]; then
359 perl -pi -e "s,$DESTDIR,," $DESTDIR$TARGETDIR/libgmp.la
360 fi
361}
362
363build_MPC() {
364 CC="$CC" ../${MPC_DIR}/configure --disable-shared --prefix=$TARGETDIR \
365 --infodir=$TARGETDIR/info --with-mpfr=$DESTDIR$TARGETDIR \
366 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
367 touch .failed
368 $MAKE $JOBS || touch .failed
369 $MAKE install DESTDIR=$DESTDIR || touch .failed
370
371 normalize_dirs
372}
373
374build_LIBELF() {
375 CC="$CC" CFLAGS="$HOSTCFLAGS" libelf_cv_elf_h_works=no \
376 ../${LIBELF_DIR}/configure --disable-shared --prefix=$TARGETDIR \
377 --infodir=$TARGETDIR/info CFLAGS="$HOSTCFLAGS" || touch .failed
378 $MAKE $JOBS || touch .failed
379 $MAKE install prefix=$DESTDIR$TARGETDIR || touch .failed
380
381 normalize_dirs
382}
383
384build_BINUTILS() {
Stefan Reinauer682a90c2015-06-09 14:59:58 -0700385 if [ $TARGETARCH == "x86_64-elf" ]; then
386 ADDITIONALTARGET=",i386-elf"
387 fi
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700388 CC="$CC" ../binutils-${BINUTILS_VERSION}/configure --prefix=$TARGETDIR \
Stefan Reinauer682a90c2015-06-09 14:59:58 -0700389 --target=${TARGETARCH} --enable-targets=${TARGETARCH}${ADDITIONALTARGET} \
390 --disable-werror --disable-nls --enable-lto --enable-gold \
391 --enable-plugins --enable-multilibs CFLAGS="$HOSTCFLAGS" || touch .failed
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700392 $MAKE $JOBS || touch .failed
393 $MAKE install DESTDIR=$DESTDIR || touch .failed
394}
395
396
397build_GCC() {
Stefan Reinauerd0f83722015-06-09 11:52:28 -0700398 # GCC does not honor HOSTCFLAGS at all. CFLAGS are used for
399 # both target and host object files.
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700400 # There's a work-around called CFLAGS_FOR_BUILD and CFLAGS_FOR_TARGET
401 # but it does not seem to work properly. At least the host library
402 # libiberty is not compiled with CFLAGS_FOR_BUILD.
403 CC="$CC" CFLAGS_FOR_TARGET="-O2" CFLAGS="$HOSTCFLAGS" \
404 CFLAGS_FOR_BUILD="$HOSTCFLAGS" ../gcc-${GCC_VERSION}/configure \
405 --prefix=$TARGETDIR --libexecdir=$TARGETDIR/lib \
406 --target=${TARGETARCH} --disable-werror --disable-shared \
Stefan Reinauer2f97ebc2015-06-09 12:24:54 -0700407 --enable-lto --enable-plugins --enable-gold --enable-ld=default \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700408 --disable-libssp --disable-bootstrap --disable-nls \
409 --disable-libquadmath --without-headers \
Stefan Reinauer2f97ebc2015-06-09 12:24:54 -0700410 ${GCC_OPTIONS} --enable-languages="c" \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700411 --with-gmp=$DESTDIR$TARGETDIR --with-mpfr=$DESTDIR$TARGETDIR \
412 --with-mpc=$DESTDIR$TARGETDIR --with-libelf=$DESTDIR$TARGETDIR \
413 --with-pkgversion="coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE" \
414 || touch .failed
415 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-gcc || touch .failed
416 $MAKE install-gcc DESTDIR=$DESTDIR || touch .failed
417
Stefan Reinauerd7649122015-06-09 11:44:25 -0700418 if [ "$(echo $TARGETARCH | grep -c -- -mingw32)" -eq 0 ]; then
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700419 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-target-libgcc || touch .failed
420 $MAKE install-target-libgcc DESTDIR=$DESTDIR || touch .failed
421 fi
422}
423
424build_EXPAT() {
425 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${EXPAT_DIR}/configure --disable-shared \
426 --prefix=$TARGETDIR --target=${TARGETARCH} || touch .failed
427 $MAKE || touch .failed
428 $MAKE install DESTDIR=$DESTDIR || touch .failed
429
430 normalize_dirs
431}
432
433build_PYTHON() {
434 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${PYTHON_DIR}/configure --prefix=$TARGETDIR \
435 --target=${TARGETARCH} || touch .failed
436 $MAKE $JOBS || touch .failed
437 $MAKE install DESTDIR=$DESTDIR || touch .failed
438
439 normalize_dirs
440}
441
442build_GDB() {
443 export PYTHONHOME=$DESTDIR$TARGETDIR
444 if [ $(uname) != "FreeBSD" -a $(uname) != "NetBSD" ]; then
445 LIBDL="-ldl"
446 fi
447 LDFLAGS="-Wl,-rpath,\$\$ORIGIN/../lib/ -L$DESTDIR$TARGETDIR/lib \
448 -lpthread $LIBDL -lutil" \
449 CC="$CC" CFLAGS="$HOSTCFLAGS -I$DESTDIR$TARGETDIR/include" \
Stefan Reinauer7b40e422015-06-09 11:56:32 -0700450 ../${GDB_DIR}/configure --prefix=$TARGETDIR \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700451 --target=${TARGETARCH} --disable-werror --disable-nls
452 $MAKE $JOBS || touch .failed
453 $MAKE install DESTDIR=$DESTDIR || touch .failed
454}
455
456build_IASL() {
457 RDIR=$PWD
458 cd ../$IASL_DIR/generate/unix
459 CFLAGS="$HOSTCFLAGS"
460 HOST="_LINUX"
461 test $UNAME = "Darwin" && HOST="_APPLE"
462 test $UNAME = "FreeBSD" && HOST="_FreeBSD"
463 test $UNAME = "Cygwin" && HOST="_CYGWIN"
464 HOST="$HOST" OPT_CFLAGS="-O -D_FORTIFY_SOURCE=2" CFLAGS="$CFLAGS" $MAKE CC="$CC" iasl || touch $RDIR/.failed
465 rm -f $DESTDIR$TARGETDIR/bin/iasl || touch $RDIR/.failed
466 cp bin/iasl $DESTDIR$TARGETDIR/bin || touch $RDIR/.failed
467}
468
469build_LLVM() {
470 cd ..
471 ln -sf $PWD/$CFE_DIR $LLVM_DIR/tools/clang
472 ln -sf $PWD/$CTE_DIR $LLVM_DIR/tools/clang/tools/extra
473 ln -sf $PWD/$CRT_DIR $LLVM_DIR/projects/compiler-rt
474 cd -
475
476 $CMAKE -G "Unix Makefiles" -DCMAKE_INSTALL_PREFIX=$DESTDIR$TARGETDIR \
477 -DCMAKE_BUILD_TYPE=Release ../$LLVM_DIR || touch .failed
478 $MAKE $JOBS || touch .failed
479 $MAKE install || touch .failed
480
481 cp -a ../$CFE_DIR/tools/scan-build/* $DESTDIR$TARGETDIR/bin
482 cp -a ../$CFE_DIR/tools/scan-view/* $DESTDIR$TARGETDIR/bin
Stefan Reinauere9e6e3d2015-07-07 00:20:42 +0200483
484 # create symlinks to work around broken --print-librt-file-name
485 # when used with -target.
486 cd $DESTDIR$TARGETDIR/lib/clang/${CLANG_VERSION}/lib
487 for i in */libclang_rt.builtins*.a; do
488 ln -s $i .
489 done
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700490}
491
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700492printf "${blue}Welcome to the ${red}coreboot${blue} cross toolchain builder v$CROSSGCC_VERSION ($CROSSGCC_DATE)${NC}\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000493
Patrick Georgi6bba29f2010-01-29 17:40:52 +0000494# Look if we have getopt. If not, build it.
495export PATH=$PATH:.
496getopt - > /dev/null 2>/dev/null || gcc -o getopt getopt.c
497
Stefan Reinauer074d9132009-09-26 16:43:17 +0000498# parse parameters.. try to find out whether we're running GNU getopt
Stefan Reinauerd7649122015-06-09 11:44:25 -0700499getoptbrand="$(getopt -V | sed -e '1!d' -e 's,^\(......\).*,\1,')"
Peter Stuge09377b72011-08-21 06:24:55 +0200500if [ "${getoptbrand}" = "getopt" ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000501 # Detected GNU getopt that supports long options.
zbao433fa572015-08-11 02:43:46 -0400502 args=$(getopt -l version,help,clean,directory:,platform:,package:,jobs:,destdir:,savetemps,scripting,ccache Vhcd:p:P:j:D:tSy -- "$@")
Stefan Reinauer074d9132009-09-26 16:43:17 +0000503 eval set "$args"
504else
505 # Detected non-GNU getopt
zbao433fa572015-08-11 02:43:46 -0400506 args=$(getopt Vhcd:p:P:j:D:tSy $*)
Stefan Reinauer074d9132009-09-26 16:43:17 +0000507 set -- $args
508fi
509
510if [ $? != 0 ]; then
511 myhelp
512 exit 1
513fi
514
515while true ; do
516 case "$1" in
517 -V|--version) shift; myversion; exit 0;;
518 -h|--help) shift; myhelp; exit 0;;
Patrick Georgi44af57a2013-12-19 22:06:22 +0100519 -c|--clean) shift; clean=1;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000520 -t|--savetemps) shift; SAVETEMPS=1;;
521 -d|--directory) shift; TARGETDIR="$1"; shift;;
522 -p|--platform) shift; TARGETARCH="$1"; shift;;
523 -D|--destdir) shift; DESTDIR="$1"; shift;;
Patrick Georgi73166c72010-04-14 20:42:42 +0000524 -j|--jobs) shift; JOBS="-j $1"; shift;;
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700525 -P|--package) shift; PACKAGE="$1"; shift;;
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100526 -S|--scripting) shift; SKIPPYTHON=0;;
Patrick Georgic1a75b12011-11-04 21:37:14 +0100527 -y|--ccache) shift; USECCACHE=1;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200528 --) shift; break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000529 -*) printf "Invalid option\n\n"; myhelp; exit 1;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200530 *) break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000531 esac
532done
533
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700534case "$TARGETARCH" in
Stefan Reinauer24f9cb92015-03-13 22:50:22 +0100535 x86_64-elf) ;;
536 x86_64*) TARGETARCH=x86_64-elf;;
David Hubbard5b0420a2013-05-28 16:33:15 -0600537 i386-elf) ;;
538 i386-mingw32) ;;
Patrick Georgi9b7efa52015-03-08 09:20:36 +0100539 mipsel-elf) ;;
Patrick Georgif0bbc952015-03-07 10:57:25 +0100540 riscv-elf) ;;
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700541 i386*) TARGETARCH=i386-elf;;
Patrick Georgic8883262013-09-19 10:57:58 +0200542 arm*) TARGETARCH=armv7-a-eabi;;
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700543 aarch64*) TARGETARCH=aarch64-elf;;
544 *) printf "${red}WARNING: Unsupported architecture $TARGETARCH.${NC}\n\n"; ;;
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700545esac
546
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700547# Figure out which packages to build
Stefan Reinauer699ac272015-06-05 12:43:28 -0700548
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700549case "$PACKAGE" in
550 GCC|gcc)
551 echo "Target architecture is now $TARGETARCH"
552 NAME="${TARGETARCH} cross GCC"
Stefan Reinauerbd8b2e32015-06-17 11:55:02 -0700553 PACKAGES="GMP MPFR MPC LIBELF BINUTILS GCC"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700554 ;;
555 GDB|gdb)
556 NAME="${TARGETARCH} cross GDB"
557 PACKAGES="GDB"
558 if [ $SKIPPYTHON -eq 0 ]; then
559 PACKAGES="EXPAT PYTHON $PACKAGES"
560 fi
561 ;;
562 CLANG|clang)
563 NAME=clang
564 PACKAGES="LLVM CFE CRT CTE"
David Hendrickscd5cdd32015-06-15 17:03:22 -0700565 CMAKE=$(searchtool cmake "cmake") || exit $?
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700566 ;;
567 IASL|iasl)
568 NAME="IASL ACPI compiler"
569 PACKAGES=IASL
570 ;;
571 *)
572 printf "${red}ERROR: Unsupported package $PACKAGE. (Supported packages are GCC, GDB, CLANG, IASL)${NC}\n\n";
573 exit 1
574 ;;
575esac
Peter Stugeceacd772011-06-09 04:54:16 +0200576
Stefan Reinauer66e93352015-06-16 22:38:23 +0200577# Find all the required tools:
578
579TAR=$(searchtool tar) || exit $?
580PATCH=$(searchtool patch) || exit $?
581MAKE=$(searchtool make) || exit $?
582SHA1SUM=$(searchtool sha1sum)
583SHA512SUM=$(searchtool sha512sum)
584CHECKSUM=$SHA1SUM
585
586searchtool m4 > /dev/null
587searchtool bison > /dev/null
588searchtool flex flex > /dev/null
589searchtool g++ "Free Software Foundation" nofail > /dev/null || \
Marc Jones5ee69512015-06-17 15:38:17 -0600590searchtool clang "clang version" nofail > /dev/null || \
591searchtool clang "LLVM" > /dev/null
Stefan Reinauer66e93352015-06-16 22:38:23 +0200592searchtool wget > /dev/null
593searchtool bzip2 "bzip2," > /dev/null
594
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700595# This initial cleanup is useful when updating the toolchain script.
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000596
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700597if [ "$clean" = "1" ]; then
598 cleanup
599fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000600
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700601# Set up host compiler and flags needed for various OSes
Stefan Reinauer074d9132009-09-26 16:43:17 +0000602
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700603CC=cc
Patrick Georgif2c15f52015-06-11 21:07:31 +0200604if is_package_enabled "GCC"; then
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700605if [ $UNAME = "Darwin" ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000606 #GCC_OPTIONS="$GCC_OPTIONS --enable-threads=posix"
607
608 # generally the OS X compiler can create x64 binaries.
609 # Per default it generated i386 binaries in 10.5 and x64
610 # binaries in 10.6 (even if the kernel is 32bit)
611 # For some weird reason, 10.5 autodetects an ABI=64 though
612 # so we're setting the ABI explicitly here.
Stefan Reinauerd7649122015-06-09 11:44:25 -0700613 if [ $(sysctl -n hw.optional.x86_64 2>/dev/null) -eq 1 ] 2>/dev/null; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000614 OPTIONS="ABI=64"
615 else
616 OPTIONS="ABI=32"
617 fi
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700618
Stefan Reinauer4266b922012-12-05 16:18:32 -0800619 # In Xcode 4.5.2 the default compiler is clang.
620 # However, this compiler fails to compile gcc 4.7.x. As a
621 # workaround it's possible to compile gcc with llvm-gcc.
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700622 if $CC -v 2>&1 | grep -q LLVM; then
Stefan Reinauer4266b922012-12-05 16:18:32 -0800623 CC=llvm-gcc
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700624 fi
zbao11f1d312015-08-05 23:15:54 -0400625elif [ $UNAME = "Linux" -o $UNAME = "Cygwin" ]; then
Patrick Georgiddb8f802015-07-04 17:45:54 +0200626 # gmp is overeager with detecting 64bit CPUs even if they run
627 # a 32bit kernel and userland.
628 if [ "$(uname -m 2>/dev/null)" = "i686" ]; then
629 OPTIONS="ABI=32"
630 fi
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000631fi
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700632fi # GCC
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000633
Patrick Georgic1a75b12011-11-04 21:37:14 +0100634if [ "$USECCACHE" = 1 ]; then
635 CC="ccache $CC"
636fi
637
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700638# Prepare target directory for building GCC
639# (dependencies must be in the PATH)
Stefan Reinauer16bd7892012-12-07 23:57:01 +0100640mkdir -p $DESTDIR$TARGETDIR/bin
641export PATH=$DESTDIR$TARGETDIR/bin:$PATH
642
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700643# Download, unpack, patch and build all packages
644
645printf "Downloading tar balls ... \n"
646mkdir -p tarballs
647for P in $PACKAGES; do
648 download $P
649done
650printf "Downloaded tar balls ... ${green}ok${NC}\n"
651
652printf "Unpacking and patching ... \n"
653for P in $PACKAGES; do
654 unpack_and_patch $P || exit 1
655done
656printf "Unpacked and patched ... ${green}ok${NC}\n"
657
658printf "Building packages ... \n"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700659for package in $PACKAGES; do
660 build $package
661done
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700662printf "Packages built ... ${green}ok${NC}\n"
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700663
Stefan Reinauer699ac272015-06-05 12:43:28 -0700664# Adding git information of current tree to target directory
665# for reproducibility
Stefan Reinauerd7649122015-06-09 11:44:25 -0700666PROGNAME=$(basename "$0")
Patrick Georgi5602f2c2015-03-28 15:48:47 +0100667rm -f "$DESTDIR$TARGETDIR/$PROGNAME".commit.*
Stefan Reinauerd7649122015-06-09 11:44:25 -0700668cp "$PROGNAME" $DESTDIR$TARGETDIR/"$PROGNAME.commit.$(git describe)"
Zheng Bao30b895f2013-02-06 18:04:40 +0800669
Stefan Reinauer074d9132009-09-26 16:43:17 +0000670if [ $SAVETEMPS -eq 0 ]; then
Stefan Reinauer699ac272015-06-05 12:43:28 -0700671 cleanup
Stefan Reinauer074d9132009-09-26 16:43:17 +0000672else
673 printf "Leaving temporary files around... ${green}ok${NC}\n"
674fi
675
Stefan Reinauer699ac272015-06-05 12:43:28 -0700676printf "\n${green}You can now run your $NAME toolchain from $TARGETDIR.${NC}\n"